#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdarg.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "mprintf.h"
#include "capture.h"
#include "gfx.h"

int
main (int argc, char **argv)
{
  vcdev_t *D;
  int fno;
  int i;
  char buf[2000];
  D = open_device ("/dev/video0");
  if (D->errcode)
    goto err_quit;

  gfx_init(NULL,D->width,D->height,0);

  start_capture (D);
  if (D->errcode)
    goto err_quit;

  while(1)
  {
    fno = read_frame (D);
    if (fno < 0)
      goto err_quit;
    cvt_rgb24(D,fno, gfx_pixels);
    gfx_update(0,0,0,0);
    putback_buffer (D, fno);
    gfx_get_event();
  }
  stop_capture (D);
  close_device (D);
  gfx_close();

  return 0;
err_quit:
  fprintf (stderr, "error %d: %s\n", D->errcode, D->error_msg);
  return 1;
}

