
#ifndef CAPTURE_DOT_H_INCLUDED
#define CAPTURE_DOT_H_INCLUDED

typedef struct
{
  int mapped;
  int index;
  int length;
  void *address;
} vcbuffer_t;
typedef struct
{
  int fd;
  char *devname;
  int errcode;
  char *error_msg;

  int height, width;
  unsigned int pixelformat;
  int bytesperline;
  int sizeimage;

  int method;

  int nbuffers;
  vcbuffer_t *buffers;
} vcdev_t;
#ifdef __cplusplus
extern "C"
{
#endif
  vcdev_t *open_device (char *devname);
  void start_capture (vcdev_t * D);
  int read_frame (vcdev_t * D);
  void putback_buffer (vcdev_t * D, int index);
  void stop_capture (vcdev_t * D);
  void close_device (vcdev_t * D);
  void enumerate_formats (vcdev_t * D);
  unsigned char *grey_buffer (vcdev_t * D);
  unsigned int *rgb24_buffer (vcdev_t * D);
  void cvt_rgb24 (vcdev_t * D, int fno, unsigned int *out);
  void cvt_grey (vcdev_t * D, int fno, unsigned char *out);
#ifdef __cplusplus
}
#endif

#endif
