
extern uint32_t *gfx_pixels;
extern int       gfx_bpl;
extern int       gfx_width;
extern int       gfx_height;

void gfx_init(void *disp,int width,int height,const char *title);
void gfx_close();

void gfx_fg(uint32_t);
void gfx_bg(uint32_t);
void gfx_update(int x,int y,int w,int h);


void gfx_draw_line(int width, int x0,int y0, int x1, int y1);
void gfx_fill_rect(int x0,int y0, int x1, int y1);
void gfx_draw_rect(int width, int x0,int y0, int x1, int y1);
void gfx_fill_circle(int x0, int y0, int radius);

typedef void (*gfx_font_func) (uint32_t *, size_t ,
              int *, int *, int *, unsigned char **);


int utf8_decode_string (const uint8_t *input, size_t ilen,
                        uint32_t *output, size_t *olen);

void gfx_text(gfx_font_func font, const char *str,int x,int y);

void gfx_button_font(gfx_font_func font);
int gfx_button(int x,int y, int w, int h, const char *text, int code);


/* EVENT HANDLING 
     The following event numbers are used by the system. 
     First event number available to widgets is GFX_LAST_EVENT_NO
*/
enum {
    GFXEV_KEY, GFXEV_KEYPRESS, GFXEV_KEYRELEASE,
               GFXEV_MOUSEPRESS, GFXEV_MOUSERELEASE,
    GFXEV_RESIZE, GFXEV_QUITREQUEST , GFX_LAST_EVENT_NO };

/* Modifier keys. This list includes both mouse buttons and modifier keys
   on the keyboard. */

enum {
   GFXMOD_MOUSE1= 1, GFXMOD_MOUSE2, GFXMOD_MOUSE3, GFXMOD_MOUSE4, GFXMOD_MOUSE5,
   GFXMOD_SHIFT, GFXMOD_LOCK, GFXMOD_CONTROL,
   GFXMOD_MOD1, GFXMOD_MOD2, GFXMOD_MOD3, GFXMOD_MOD4, GFXMOD_MOD5, };

void gfx_wait_event(int *evcode,int *args);


