

#include <sys/types.h>
#include <ctype.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>


#include "mprintf.h"

 static  int do_div(long long int *x,int y)  ;


void *
__unused_mprintf_c

	[]= {
	
	0,
};





size_t strnlen(const char*,size_t);

/* This source does not define an output file.
      You need to define it using library or
      program directives in another file 
      Probably it`s best to put this in its
      own file since there are a couple of
      #defines which can affect the operation
      of the other code if placed in a file
      with something that uses the defined
      symbols for other purposes */

/* 
 *  linux/lib/vsprintf.c
 *
 *  Copyright (C) 1991, 1992  Linus Torvalds
 */

/* vsprintf.c -- Lars Wirzenius & Linus Torvalds. */
/*
 * Wirzenius wrote this portably, Torvalds fucked it up :-)
 */

/* 
 * Fri Jul 13 2001 Crutcher Dunnavant
	<crutcher+kernel@datastacks.com>
 * - changed to provide snprintf and vsnprintf functions
 */

/* 20031029  Sukru Cinar 
 * - modified to provide genprintf 
 */
 
/* 20070205 Sukru Cinar
  * - ported to the .w format 
  */

/* 20090713 Sukru Cinar
 *  - made it possible to include it as an applib library file
 */




static int skip_atoi(const char **s)
{
	int i=0;

	while (isdigit(**s))
		i = i*10 + *((*s)++) - '0';
	return i;
}

#define ZEROPAD	1		/* pad with zero */
#define SIGN	2		/* unsigned/signed long */
#define PLUS	4		/* show plus */
#define SPACE	8		/* space if plus */
#define LEFT	16		/* left justified */
#define SPECIAL	32		/* 0 x */
#define LARGE	64		/* use 'ABCDEF' instead of 'abcdef' */


#define WRITE(x,y) do {\
	if (write) \
		(*write)(arg, x, y);\
	written+= y;\
} while(0)

static char zerochar='0',
		    spacechar=' ',
		    percentchar='%'
		    ;
#ifdef do_div
#undef do_div
#endif

 static  int do_div(long long int *x,int y)  {
	int ret= *x % y;
	*x/= y;
	return ret;
}

static size_t number(
	void (*write)(void *,const char *,size_t), void *arg,
	long long num, int base, int size, int precision, int type)
{
	size_t written= 0;
	char c,sign,tmp[66];
	const char *digits;
	const char small_digits[] =
		"0123456789abcdefghijklmnopqrstuvwxyz";
	const char large_digits[] =
		"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	int i;

	digits = (type & LARGE) ? large_digits : small_digits;
	if (type & LEFT)
		type &= ~ZEROPAD;
	if (base < 2 || base > 36)
		return 0;
	c = (type & ZEROPAD) ? '0' : ' ';
	sign = 0;
	if (type & SIGN) {
		if (num < 0) {
			sign = '-';
			num = -num;
			size--;
		} else if (type & PLUS) {
			sign = '+';
			size--;
		} else if (type & SPACE) {
			sign = ' ';
			size--;
		}
	}
	if (type & SPECIAL) {
		if (base == 16)
			size -= 2;
		else if (base == 8)
			size--;
	}
	i = 0;
	if (num == 0)
		tmp[i++]='0';
	else while (num != 0)
		tmp[i++] = digits[do_div(&num,base)];
	if (i > precision)
		precision = i;
	size -= precision;
	if (!(type&(ZEROPAD+LEFT))) {
		while(size-->0) {
			WRITE(&spacechar,1);
		}
	}
	if (sign) {
		WRITE(&sign,1);
	}
	if (type & SPECIAL) {
		if (base==8) {
			WRITE(&zerochar,1);
		} else if (base==16) {
			WRITE(&zerochar,1);
			WRITE(digits+33,1);
		}
	}
	if (!(type & LEFT)) {
		while (size-- > 0) {
			WRITE(&c,1);
		}
	}
	while (i < precision--) {
		WRITE(&zerochar,1);
	}
	while (i-- > 0) {
		WRITE(tmp+i,1);
	}
	while (size-- > 0) {
		WRITE(&spacechar,1);
	}
	return written;
}

/**
* vsnprintf - Format a string and place it in a buffer
* @buf: The buffer to place the result into
* @size: The size of the buffer, including the trailing null space
* @fmt: The format string to use
* @args: Arguments for the format string
*
* Call this function if you are already dealing with a va_list.
* You probably want snprintf instead.
*/
 size_t vgenprintf(
	void (*write)(void *arg,const char *buf,size_t len), void *arg,
	const char *fmt, va_list args)
{
	size_t written= 0;
	int len;
	unsigned long long num;
	int  base;
	char c;
	const char *s;
	int eno= errno;

	int flags;		/* flags to number() */

	int field_width;	/* width of output field */
	int precision;		/* min. # of digits for integers; max
				   number of chars for from string */
	int qualifier;		/* 'h', 'l', or 'L' for integer fields */
				/* 'z' support added 23/7/1999 S.H.    */
				/* 'z' changed to 'Z' --davidm 1/25/99 */

	for (; *fmt ; ++fmt) {
		if (*fmt != '%') {
			WRITE(fmt,1);
			continue;
		}

		/* process flags */
		flags = 0;
		repeat:
			++fmt;		/* this also skips first '%' */
			switch (*fmt) {
				case '-': flags |= LEFT; goto repeat;
				case '+': flags |= PLUS; goto repeat;
				case ' ': flags |= SPACE; goto repeat;
				case '#': flags |= SPECIAL; goto repeat;
				case '0': flags |= ZEROPAD; goto repeat;
			}

		/* get field width */
		field_width = -1;
		if (isdigit(*fmt))
			field_width = skip_atoi(&fmt);
		else if (*fmt == '*') {
			++fmt;
			/* it`s the next argument */
			field_width = va_arg(args, int);
			if (field_width < 0) {
				field_width = -field_width;
				flags |= LEFT;
			}
		}

		/* get the precision */
		precision = -1;
		if (*fmt == '.') {
			++fmt;	
			if (isdigit(*fmt))
				precision = skip_atoi(&fmt);
			else if (*fmt == '*') {
				++fmt;
				/* it`s the next argument */
				precision = va_arg(args, int);
			}
			if (precision < 0)
				precision = 0;
		}

		/* get the conversion qualifier */
		qualifier = -1;
		if (*fmt == 'h' || *fmt == 'l' || *fmt == 'L' || *fmt =='Z'
		   || *fmt=='r' ) {
			qualifier = *fmt;
			++fmt;
			if (qualifier == 'l' && *fmt == 'l') {
				qualifier = 'L';
				++fmt;
			}
		}

		/* default base */
		base = 10;

		switch (*fmt) {
			case 'c':
				if (!(flags & LEFT)) {
					while (--field_width > 0) {
						WRITE(&spacechar,1);
					}
				}
				c = (unsigned char) va_arg(args, int);
				WRITE(&c,1);
				while (--field_width > 0) {
					WRITE(&spacechar,1);
				}
				continue;

			case 'R':
			case 's':
				if (*fmt=='s')
					s = va_arg(args, char *);
				else
					s= strerror(eno);
				if (!s)
					s = "<NULL>";

				len = strnlen(s, precision);

				if (!(flags & LEFT)) {
					while (len < field_width--) {
						WRITE(&spacechar,1);
					}
				}
				WRITE(s,len);
				while (len < field_width--) {
					WRITE(&spacechar,1);
				}
				continue;
			case 'p':
				if (field_width == -1) {
					field_width = 2*sizeof(void *);
					flags |= ZEROPAD;
				}
				written+= number( write, arg,
						(unsigned long) va_arg(args, void *),
						16, field_width, precision, flags);
				continue;


			case 'n':
				/* FIXME:
				* What does C99 say about the overflow case here? */
				if (qualifier == 'l') {
					long * ip = va_arg(args, long *);
					*ip = written;
				} else if (qualifier == 'Z') {
					size_t * ip = va_arg(args, size_t *);
					*ip = written;
				} else {
					int * ip = va_arg(args, int *);
					*ip = written;
				}
				continue;

			case '%':
				WRITE(&percentchar,1);
				continue;

				/* integer number formats - set up the flags and "break" */
			case 'o':
				base = 8;
				break;

			case 'X':
				flags |= LARGE;
			case 'x':
				base = 16;
				break;

			case 'd':
			case 'i':
				flags |= SIGN;
			case 'u':
				break;

			default:
				WRITE(&percentchar,1);
				if (*fmt) {
					WRITE(fmt,1);
				} else {
					--fmt;
				}
				continue;
		}
		if (qualifier == 'L')
			num = va_arg(args, long long);
		else if (qualifier == 'l') {
			num = va_arg(args, unsigned long);
			if (flags & SIGN)
				num = (signed long) num;
		} else if (qualifier == 'Z') {
			num = va_arg(args, size_t);
		} else if (qualifier == 'h') {
			num = (unsigned short) va_arg(args, int);
			if (flags & SIGN)
				num = (signed short) num;
		} else if (qualifier == 'r') {
			num= eno;
		} else {
			num = va_arg(args, unsigned int);
			if (flags & SIGN)
				num = (signed int) num;
		}
		written+= number(write, arg,
				num, base,
				field_width, precision, flags);
	}
/*	WRITE(&nullchar,1);*/
	return written;
}


 size_t genprintf(
	void (*write)(void *arg,const char *buf,size_t len),
	  void *arg, const char *fmt, ... )
{
	va_list ap;
	size_t ret;
	va_start(ap,fmt);
	ret= vgenprintf(write, arg, fmt, ap);
	va_end(ap);
	return ret;
}

 size_t fdprintf(int fd, const char *fmt, ...) {
	va_list ap;
	size_t ret;
	va_start(ap,fmt);
	ret= vgenprintf((void*) write, (void*) fd, fmt, ap);
	va_end(ap);
	return ret;
}

static void write_buf(char **x,const char *b,size_t len) {
	memcpy(*x,b,len);
	*x += len;
}

 char *vmprintf(const char *fmt, va_list ap) {
	va_list ap2;
	size_t size;
	char *ret,*x;
	int eno= errno;
	va_copy(ap2,ap);
	size= vgenprintf(0,0, fmt, ap2);
	va_end(ap2);
	x= ret= malloc(size+1);
	if (ret) {
		errno= eno;
		vgenprintf((void*) write_buf,(void*) &x,fmt,ap);
		ret[size]= 0;
	}
	return ret;
}

 size_t vnprintf(const char *fmt, va_list ap) {
	return vgenprintf(0,0,fmt,ap);
}

 char *
mprintf(const char *fmt, ...) {
	va_list ap;
	char *ret;
	va_start(ap,fmt);
	ret= vmprintf(fmt, ap);
	va_end(ap);
	return ret;
}



